
import formatTime from "@/utils/formatTime";
import food from "@/assets/icons/ProCard/food.png";
import ProCard_hot from "@/assets/icons/ProCard/ProCard_hot.png";
import QRcode from "@/assets/icons/UserCenter/QRcode.png";

import './style.less'


export default (props) => {

  const { item, onWrite } = props

  return (
    <view class='wrapper'>
      <view class='left-complete-one'>
        <image className='left-image-1' src={ProCard_hot}></image>
        <view className='left-viewText'>
          返现￥{(item.cashback / 100).toFixed(2)}
        </view>
        <view className='title-image'>
          <image
            className='image-1'
            mode='scaleToFill'
            src={item.poster || []}
          ></image>
          <image className='image-2' src={food}></image>
        </view>
        <view className='title-content'>
          <view className='Pro-title'>
            <view className='title-text'>
              {item.packageDescription}
              <text className='title-money-2'>
                数量：{item.amount}张
              </text>
            </view>
          </view>
          <text className='title-money'>
            ￥{(item.unitPrice / 100).toFixed(2)}元
          </text>
          <view className='title-time'>
            有效期：{formatTime(item?.startTime, "yyyy/MM/dd")}-
            {formatTime(item.endTime, "yyyy/MM/dd")}
          </view>
        </view>
      </view>
      <view class='right-complete-two'>
        <view
          className='right-content'
          onClick={() => onWrite(item)}
        >
          <image className='right-image' src={QRcode} />
          <view className='right-title'>扫码核销</view>
        </view>
      </view>
    </view>
  )
}
