import { saveFeedback } from '@/services/mine'
import CustomNav from '@/components/CustomNav'
import Taro from '@tarojs/taro'
import { Image, Button } from '@tarojs/components'
import withLayout from '@/layouts'
import './style.less'


export default withLayout((props) => {
  const { person } = props
  const { personId } = person
  const back = () => {
    Taro.navigateBack()
  }
  const submit = () => {
    var content = document.getElementById('content').value
    if (content != '') {
      saveFeedback({
        personId,
        content
      }).then(() => {
      })
    }
    else {
      Taro.showToast({
        title: '请重新输入',
        icon: 'none',
        duration: 2000
      })
    }
  }
  return (
    <view className='box-content'>
      <CustomNav title='联系我们' />
      <view style={{ padding: '60rpx 30rpx' }}>
        <view class='section'>
          <textarea autoHeight placeholder='请输入您的建议或意见!' id='content' />
        </view>
        <view className='weChate-image' >
          <Image mode='aspectFit' src='https://yz-shigongli.oss-cn-shanghai.aliyuncs.com/images/%E5%BE%AE%E4%BF%A1%E5%9B%BE%E7%89%87_20210918145337.png' />
        </view>

        <view className='button-info'>
          <Button className='button-box' onClick={submit}>提交</Button>
          <Button className='button-box-Cancel' onClick={back} >取消</Button>
        </view>
      </view>
    </view>
  )
})
